<?php
	error_reporting(E_ERROR);
	$tmpFile = $_ENV["CR_TMPDIR"].'/node_debug_vars_'.$_ENV["CR_RUNID"].'.json';
	$time = 0;
	while (!file_exists($tmpFile) || !($data = file_get_contents($tmpFile))) {
		usleep(1e4);
		$time += 1e4;
		if ($time > 4e6) {
			// Timeout
			exit;
		}
	}
	unlink($tmpFile);
	$showAll = $_ENV["CR_DEBUGGER_VARIABLES_SHOW_ALL"] == 1;
	$array = json_decode($data, true);
	if (!$array) {
		exit;
	}
	function traverse($obj, $isarray = false) {
		global $showAll;
		$return = array();
		foreach ($obj as $dict) {
			if ($dict["priority"] < 0 && !$showAll) {
				continue;
			}
			$name = $dict["name"];
			if ($isarray && "$name" !== "".(intval($name))) {
				continue;
			}
			$kind = $dict["kind"];
			if (!$kind) {
				$kind = "variable";
			}
			$type = $dict["value"]["type"];
			$value = null;
			if (isset($dict["value"]["value"])) {
				$value = $dict["value"]["value"];
			}
			$description = $dict["value"]["description"];
			switch ($type) {
				case "function":
					$kind = $type;
					break;
				case "string":
					$value = json_encode($value, JSON_UNESCAPED_SLASHES);
					break;
				case "boolean":
					$value = $value ? "true" : "false";
					break;
				case "undefined":
					$value = "undefined";
					$type = "";
					break;
				case "object":
					if (isset($dict["value"]["subtype"])) {
						$type = $dict["value"]["subtype"];
						if ($type === "null") {
							$value = "null";
						} else if ($type === "date" || $type === "regexp") {
							$value = $description;
						}
					}
					break;
			}
			if ($value === null) {
				if ($description) {
					if ($dict["value"]["className"] === $description && $kind != "function") {
						$value = "[$description]";
					} else {
						$value = $description;
					}
				}
				if (!$value) {
					$value = $dict["value"];
				}
				if ($value === null) {
					continue;
				}
			}
			if (is_array($value) && $dict["value"]["shouldRecurse"]) {
				$value = traverse($value, $type == "array");
			} else if (is_string($value) && strlen($value) > 999) {
				$value = substr($value, 0, 999)."…";
			}
			array_push($return, array(
				"name" => $name,
				"value" => $value,
				"type" => $type,
				"kind" => $kind
			));
		}
		return $return;
	}
	echo json_encode(traverse($array));
?>
